/*
 * factory.h - PacketFactory - produces commonly used packet types
 *
 * Written by Michael "Mr. Sump" Poppitz.
 *
 */

 /***************************************************************************
  *                                                                         *
  *   This program is free software; you can redistribute it and/or modify  *
  *   it under the terms of the GNU General Public License as published by  *
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
  ***************************************************************************/

#ifndef FACTORY_H
#define FACTORY_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "packet.h"

class PacketFactory {
	public:
		PacketFactory();
		~PacketFactory();

		Packet *produceSABM(char *src, int sssid, char *dest, int dssid);
		Packet *produceDISC(char *src, int sssid, char *dest, int dssid);
		Packet *produceUI(char *src, int sssid, char *dest, int dssid, char *msg);
		Packet *produceBeacon(char *src, int sssid, char *dest, int dssid, char *msg);

		Packet *produceI(char *src, int sssid, char *dest, int dssid, int pid, unsigned char *text, int len, int rseq, int sseq, bool cr);

	private:
		void setBasics(Packet *p, char *src, int sssid, char *dest, int dssid);
};

#endif

/**** That's all *********************************************************/
